var ct;
var dateTimeFormat = "mm/dd/yy hh:ii:ss";
/*******************************
 * a  - ante meridiem and post meridiem
d  - day of month (no leading zero)
dd - day of month (two digit)
o  - day of year (no leading zeros)
oo - day of year (three digit)
D  - day name short
DD - day name long
g  - 12-hour hour format of day (no leading zero)
gg - 12-hour hour format of day (two digit)
h  - 24-hour hour format of day (no leading zero)
hh - 24-hour hour format of day (two digit)
u  - millisecond of second (no leading zeros)
uu - millisecond of second (three digit)
i  - minute of hour (no leading zero)
ii - minute of hour (two digit)
m  - month of year (no leading zero)
mm - month of year (two digit)
M  - month name short
MM - month name long
S  - ordinal suffix for the previous unit
s  - second of minute (no leading zero)
ss - second of minute (two digit)
y  - year (two digit)
yy - year (four digit)
@  - Unix timestamp (ms since 01/01/1970)
!  - Windows ticks (100ns since 01/01/0001)
'...' - literal text
'' - single quote
***********************/

function convertTojQueryFormat(javaFormat)
{
	var jQueryFormat = javaFormat.replace(/[\W]*s+[\.s+]/, "").replace(/m/g, "i").replace(/H/g, "h").replace(/M/g, "m").replace(/yy/g, "y");
	return jQueryFormat;
}

function tzone(tz, os, ds)
{

	this.ct = '';		// datetime
	this.tz = tz ;		// code
	this.os = os ;		// GMT offset
	this.ds = ds ;		// has daylight savings
}

function updateClocks()
{
	var browserDate = new Date();
	// compensate time zones
	var gmtd = new Date(browserDate.getTime() + (browserDate.getTimezoneOffset() * 60000));
	for (n=0 ; n<ct.length ; n++)
	{
		ct[n].ct = new Date(gmtd.getTime() + (ct[n].os * 3600000)) ;
		document.getElementById(ct[n].tz).innerHTML = $.formatDateTime(dateTimeFormat, ct[n].ct);
		//document.getElementById(ct[n].tz).innerHTML = clockString(ct[n].ct) ;
	}

	var timerID = window.setTimeout(updateClocks, 30000) ;
}

function clockString(dt)
{

	var stemp, ampm ;
	var dt_year = dt.getFullYear() ;
	var dt_month = dt.getMonth() + 1 ;
	var dt_day = dt.getDate() ;
	var dt_hour = dt.getHours() ;
	var dt_minute = dt.getMinutes() ;

	dt_year = dt_year.toString() ;

	if (0 <= dt_hour && dt_hour < 12)
	{
		ampm = 'AM' ;
		if (dt_hour == 0) dt_hour = 12 ;

	} else {
		ampm = 'PM' ;
		dt_hour = dt_hour - 12 ;
		if (dt_hour == 0) dt_hour = 12 ;
	}

	if (dt_minute < 10)
		dt_minute = '0' + dt_minute ;

	stemp = dt_month + '/' + dt_day + '/' + dt_year.substr(2,2) ;
	stemp = stemp + ' ' + dt_hour + ":" + dt_minute +' ' + ampm ;

	return stemp ;
}

function loadMap(theMap)
{
	setMapOption(theMap);
	window.location.assign(theMap);
}

function createZones(geo)
{
	// add time zones for all geo's
	if (geo=="US")
	{
		ct = new Array(
		new tzone('HT', -10, 1),
		new tzone('AKT', -9, 1),
		new tzone('PT', -8, 1),
		new tzone('MT', -7, 1),
		new tzone('CT', -6, 1),
		new tzone('ET', -5, 1)
		);

		var browserDate = new Date();

		// 2nd Sunday in March for US (possible values:  March 8 to March 14)
		var startDST = new Date(browserDate.getFullYear(),2,8)
		var daysToSunday = (7 - startDST.getDay())% 7;
		startDST.setDate(startDST.getDate() + daysToSunday);

		// 1st Sunday in November for US (possible values: Nov 1 - Nov 7)
		var endDST = new Date(browserDate.getFullYear(),10,1);
		daysToSunday = (7-endDST.getDay()) % 7;
		endDST.setDate(endDST.getDate() + daysToSunday);

		var ds_active ;		// DS currently active
		if (startDST < browserDate && browserDate < endDST)
			ds_active = 1 ;
		else
			ds_active = 0 ;

		// Adjust each clock offset if that clock has DS and in DS
		for(var n=0 ; n<ct.length ; n++)
		{
			if (ct[n].ds == 1 && ds_active == 1)
			{
				ct[n].os++ ;
			}
		}
	}
}


function setUpAndDisplayMap(geo, format)
{
	if ( format )
		dateTimeFormat = convertTojQueryFormat(format);
	createZones(geo);
	updateClocks();
}

function setMapOption(mapVal)
{
	var geoInternal = document.getElementById("geoLoc");
	for (idx=0; idx < geoInternal.length; idx++) {
		if (geoInternal.options[idx].value==mapVal)
		{
		 geoInternal.options.selectedIndex=idx;
		 break;
		}
	}
}