<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>

<fmt:setBundle var="alertTypeLabelResourceBundle" scope="request" basename="com.sas.finserv.creditfraud.fcm.util.AlertTypeLabelResourceBundle" />

<%-- Push component attributes in page context --%>
<tiles:importAttribute/>


<title>Report</title>
<style type="text/css">@import "common/styles/cf.css";</style>
<style type="text/css">@import "common/styles/calendar.css";</style>

<script language=JavaScript src="common/scripts/dateUtil.js"></script>
<script language=JavaScript src="common/scripts/calendar.js"></script>
<script language=JavaScript src="common/scripts/calendarTime.js"></script>
<script language=JavaScript src="reports/scripts/reports.js"></script>
<script type="text/javascript" src="common/scripts/jquery.cascade.js"></script>
<script type="text/javascript" src="common/scripts/jquery.field.js"></script>

<script language="JavaScript">
	$(document).ready(function(){
		DateUtil.setDefaultDateTimeFormat('${esapi:encodeForJavaScript(dateTimeFormat)}');
		DateUtil.setDefaultDateFormat('${esapi:encodeForJavaScript(dateFormat)}');
		DateUtil.setDefaultTimeFormat('${esapi:encodeForJavaScript(timeFormat)}');
      DateUtil.setMonthNames('${calendarMonthNames},${calendarShortMonthNames}'); <%-- do not html encode --%>
      DateUtil.setDayNames('${calendarFullDayNames},${calendarDayNames}'); <%-- do not html encode --%>
      DateUtil.setAmPmNames('${calendarAmPm}'); <%--  do not html encode --%>

		CalendarTime.setDateFormat('${esapi:encodeForJavaScript(dateTimeFormat)}');
	   CalendarTime.setMonthNames('${calendarMonthNames}'); <%-- do not html encode --%>
	   CalendarTime.setDayNames('${calendarDayNames}'); <%-- do not html encode --%>
		CalendarTime.setShowMonthAfterYear(${esapi:encodeForJavaScript(calendarShowMonthAfterYear)});
		CalendarTime.setWeekStartDay(${esapi:encodeForJavaScript(calendarFirstDayOfWeek)});
		CalendarTime.setDateFormat("${esapi:encodeForJavaScript(dateFormat)}");

		var cal1 = CalendarTime.newPopup("1",false,false);
		cal1.setCssPrefix("FCM");
		cal1.offsetX=18;
		cal1.offsetY=0;
		$("#calAnchor1").click(function(){cal1.open();});
		$("#calAnchor1").keydown(function(event){cal1.open(event);});

		var cal2 = CalendarTime.newPopup("2",false,false);
		cal2.setCssPrefix("FCM");
		cal2.offsetX=18;
		cal2.offsetY=0;
		$("#calAnchor2").click(function(){cal2.open();});
		$("#calAnchor2").keydown(function(event){cal2.open(event);});

		var cal3 = CalendarTime.newPopup("3",false,false);
		cal3.setCssPrefix("FCM");
		cal3.offsetX=18;
		cal3.offsetY=0;
		$("#calAnchor3").click(function(){cal3.open();});
		$("#calAnchor3").keydown(function(event){cal3.open(event);});
		$(":radio[name='alertType']:first").prop("checked",true);


		/***cascading filters**/
		//want to also cascade when the Select All checkbox is changed
		$('#BUcheckbox').change(function() { unselect=false;$('#businessUnit').trigger('change');});
		<c:if test="${not empty strategyListR}">
			//want to also cascade when the Select All checkbox is changed
			$('#Strcheckbox').change(function(){unselect=false;$('#strategy').trigger('change');});
			$("#strategy").cascade($("#businessUnit"),{
				list: strategies,
				template: commonTemplate,
				event:"change",
				match: function(selectedValue) {
					var when = this.When;
					var matches = false;
					jQuery.each(jQuery.makeArray(selectedValue),function(index){
						if(this == when) {
							matches = true;
							return false;
						}
					});
					unselect=false;
					$('#Strcheckbox').prop('checked', true);
					return matches;

				}
			});

		</c:if>
		<c:if test="${not empty groupList}">
			$('#Groupcheckbox').change(function(){unselect=false;$('#group').trigger('change');});
			$("#group").cascade($("#businessUnit"),{
				list: groups,
				template: commonTemplate,
				event:"change",
				match: function(selectedValue) {
					var when = this.When;
					var matches = false;
					jQuery.each(jQuery.makeArray(selectedValue),function(index){
						if(this == when) {
							matches = true;
							return false;
						}
					});
					unselect=false;
					$('#Groupcheckbox').prop('checked', true);
					return matches;
				}
			});
		</c:if>
		<c:if test="${not empty supervisorList}">
			$('#Supcheckbox').change(function(){unselect=false;$('#supervisor').trigger('change');});
			<c:choose>
				<c:when test="${not empty groupList}">
					$("#supervisor").cascade($("#group"),{
				</c:when>
				<c:otherwise>
					$("#supervisor").cascade($("#businessUnit"),{
				</c:otherwise>
			</c:choose>
				list: supervisors,
				template: commonTemplate,
				event:"change",
				match: function(selectedValue) {
					var when = this.When;
					var matches = false;
					jQuery.each(jQuery.makeArray(selectedValue),function(index){
						if(this == when) {
							matches = true;
							return false;
						}
					});
					unselect=false;
					$('#Supcheckbox').prop('checked', true);
					return matches;
				}
			});
		</c:if>
		<c:if test="${not empty agentList}">
			<c:choose>
				<c:when test="${not empty supervisorList}">
					$("#agent").cascade($("#supervisor"),{
				</c:when>
				<c:otherwise>
					$("#agent").cascade($("#businessUnit"),{
				</c:otherwise>
			</c:choose>
				list: agents,
				template: commonTemplate,
				event:"change",
				match: function(selectedValue) {
					var when = this.When;
					var matches = false;
					jQuery.each(jQuery.makeArray(selectedValue),function(index){
						if(this == when) {
							matches = true;
							return false;
						}
					});
					unselect=false;
					$('#Agentcheckbox').prop('checked', true);
					return matches;
				}
			});
		</c:if>
		<c:if test="${not empty queueList}">
			$('#Queuecheckbox').change(function(){unselect=false;$('#queue').trigger('change');});
			<c:choose>
				<c:when test="${not empty strategyListR}">
					//using strategy
					$("#queue").cascade($("#strategy"),{
				</c:when>
				<c:otherwise>
					//using business unit
					$("#queue").cascade($("#businessUnit"),{
				</c:otherwise>
			</c:choose>
				list: queues,
				template: commonTemplate,
				event:"change",
				match: function(selectedValue) {
					var when = this.When;
					var matches = false;
					jQuery.each(jQuery.makeArray(selectedValue),function(index){
						if(this == when) {
							matches = true;
							return false;
						}
					});
					unselect=false;
					$('#Queuecheckbox').prop('checked', true);
					return matches;
				}
			});
		</c:if>
		<c:if test="${not empty ruleList}">
			$("#rule").cascade($("#queue"),{
				list: rules,
				template: commonTemplate,
				event:"change",
				match: function(selectedValue) {
					var when = this.When;
					var matches = false;
					jQuery.each(jQuery.makeArray(selectedValue),function(index){
						if(this == when) {
							matches = true;
							return false;
						}
					});
					unselect=false;
					$('#Rulecheckbox').prop('checked', true);
					return matches;
				}
			});
		</c:if>
		<c:if test="${not empty queueList}">
		$('#queuecheckbox').change(function(){unselect=false;$('#queue').trigger('change');});
		$('#alertType').cascade($('#queue'),{
			list: alertTypes,
			template: commonTemplate,
			event:"change",
			match: function(selectedValue) {
				var when = this.When;
				var matches = false;
				jQuery.each(jQuery.makeArray(selectedValue),function(index){
					if(this == when) {
						matches = true;
						return false;
					}
				});
				unselect=false;
				$('#alertcheckbox').prop('checked', true);
				return matches;
			}
		});
	</c:if>
	<c:if test="${not empty ruleList}">
		$('#rulecheckbox').change(function(){unselect=false;$('#rule').trigger('change');});
		$('#alertType').cascade($('#rule'),{
			list: alertTypeRules,
			template: commonTemplate,
			event:"change",
			match: function(selectedValue) {
				var when = this.When;
				var matches = false;
				jQuery.each(jQuery.makeArray(selectedValue),function(index){
					if(this == when) {
						matches = true;
						return false;
					}
				});
				unselect=false;
				$('#alertcheckbox').prop('checked', true);
				return matches;
			}
		});
		$('#alertType').bind('cascade',function(){
			var usedNames = {};
			$("select[id='alertType'] > option").each(function () {
    			if(usedNames[this.value]) {
        			$(this).remove();
        		}else{
        			usedNames[this.value] = this.value;
    			}
			});
		});
		<c:if test="${reportSpecs.reportType=='viewRulesFired'}">
		$('#queue').bind('cascade',function(){
			var exists = false;
			$('#queue option').each(function(){
			    if (this.value == '?') {
			        exists = true;
			        return false;
			    }
			});
			var length = $('#queue > option').length;
			if(length!=0  && exists ==false)$('#queue').prepend('<option value="?">N/A</option>');
		});
		</c:if>
	</c:if>

});
</script>
<script language="JavaScript">
    	function commonTemplate(item) {
    		return "<option value='" + item.Value + "' selected>" + item.Text + "</option>";
    	};

    	function commonMatch(selectedValue) {
    		return this.When == selectedValue;
	};


/***FILTER BY BUSINESS UNIT***/
<c:if test="${not empty strategyListR}">
	var strategies = [
	<c:forEach var="strategy" items="${strategyListR}">
	<c:set var="strategyName" value="${strategy.name}"/>
		<c:if test="${fn:length(strategy.name) > 50}">
			<c:set var="strategyName" value="${fn:substring(strategy.name,0,50)}..."/>
		</c:if>
		<c:if test="${reportDataSource == null}">
			{'When':'${esapi:encodeForJavaScript(strategy.businessUnit)}', 'Value':'${strategy.id}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(strategy.businessUnitName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(strategyName))}'},
		</c:if>
		<c:if test="${reportDataSource== 'sor'}">
			<c:if test="${strategy.name!=null}">
				{'When':'${esapi:encodeForJavaScript(strategy.businessUnitName)}', 'Value':'${esapi:encodeForJavaScript(strategy.name)}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(strategy.businessUnitName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(strategyName))}'},
			</c:if>
		</c:if>
	</c:forEach>
	];
</c:if>

<c:if test="${empty groupList}">
	<c:if test="${not empty supervisorList}">
			var supervisors=[
			<c:forEach var="supervisor" items="${supervisorList}">
				{'When':'${supervisor.buID}', 'Value':'${supervisor.supervisorID}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(supervisor.buName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(supervisor.supervisorName))}'},
			</c:forEach>
			];
	</c:if>
</c:if>
<c:if test="${empty supervisorList}">
	<c:if test="${not empty agentList}">
		var agents=[
		<c:forEach var="agent" items="${agentList}">
			{'When':'${agent.buID}', 'Value':'${agent.agentID}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(agent.buName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(agent.agentName))}'},
		</c:forEach>
		];
	</c:if>
</c:if>
<c:if test="${empty strategyListR}">
	<c:if test="${not empty queueList}">
		var queues=[
		<c:forEach var="queue" items="${queueList}">
			<c:if test="${reportDataSource == null}">
				{'When':'${esapi:encodeForJavaScript(queue.businessUnit)}', 'Value':'${queue.id}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(queue.businessUnitName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(queue.name))}'},
			</c:if>
			<c:if test="${reportDataSource == 'sor'}">
				<c:if test="${queue.name!=null}">
					{'When':'${esapi:encodeForJavaScript(queue.businessUnitName)}', 'Value':'${esapi:encodeForJavaScript(queue.name)}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(queue.businessUnitName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(queue.name))}'},
				</c:if>
			</c:if>
		</c:forEach>
		];
	</c:if>
</c:if>

/***FILTER BY TEAM***/
<c:if test="${not empty groupList}">
	var groups=[
	<c:forEach var="group" items="${groupList}">
		{'When':'${group.bu}', 'Value':'${group.groupID}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(group.buName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(group.groupName))}'},
	</c:forEach>

	];
	<c:if test="${not empty supervisorList}">
		var supervisors=[
		<c:forEach var="supervisor" items="${supervisorList}">
			{'When':'${supervisor.groupID}', 'Value':'${supervisor.supervisorID}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(supervisor.buName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(supervisor.supervisorName))}'},
		</c:forEach>
		];
	</c:if>
</c:if>
/***FILTER BY SUPERVISOR***/
<c:if test="${not empty supervisorList}">
	<c:if test="${not empty agentList}">
		var agents=[
		<c:forEach var="agent" items="${agentList}">
			{'When':'${agent.supervisorID}', 'Value':'${agent.agentID}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(agent.buName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(agent.agentName))}'},
		</c:forEach>
		];
	</c:if>
</c:if>
/***FILTER BY STRATEGY***/
<c:if test="${not empty strategyListR}">
	<c:if test="${not empty queueList}">
		var queues=[
		<c:forEach var="queue" items="${queueList}">
			<c:if test="${reportDataSource == null}">
				{'When':'${queue.strategyId}', 'Value':'${queue.id}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(queue.businessUnitName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(queue.name))}'},
			</c:if>
			<c:if test="${reportDataSource == 'sor'}">
				{'When':'${esapi:encodeForJavaScript(queue.strategyName)}', 'Value':'${esapi:encodeForJavaScript(queue.name)}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(queue.businessUnitName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(queue.name))}'},
			</c:if>
		</c:forEach>
		];
	</c:if>
	<c:if test="${reportDataSource== 'sor'}">
		<c:if test="${not empty alertType}">
		var alertTypes=[
		<c:forEach var="queue"  items="${queueList}">
			<c:forEach var="alertType" items="${alertType}">
					{'When':'${esapi:encodeForJavaScript(queue.name)}', 'Value':'${esapi:encodeForJavaScript(alertType.code)}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(alertType.name))}'},
			</c:forEach>
		</c:forEach>
		];
		var alertTypeRules=[
			<c:forEach var="queue"  items="${queueList}">
				<c:forEach var="rule"  items="${ruleList}">
					<c:if test="${queue.name == rule.queueName && queue.id !='?'}">
						<c:forEach var="alertType" items="${alertType}">
								{'When':'${esapi:encodeForJavaScript(rule.name)}', 'Value':'${esapi:encodeForJavaScript(alertType.code)}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(alertType.name))}'},
						</c:forEach>
					</c:if>
				</c:forEach>
			</c:forEach>
	    ];

		</c:if>
	</c:if>
	</c:if>
	/***FILTER BY QUEUE***/
	<c:if test="${not empty queueList}">
		<c:if test="${not empty ruleList}">
			var rules=[
			<c:forEach var="rule" items="${ruleList}">
				<c:choose>
					<c:when test="${rule.queueName=='N/A'}">
						{'When':'?', 'Value':'${esapi:encodeForJavaScript(rule.name)}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(rule.queueName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(rule.name))}'},
					</c:when>
					<c:otherwise>
						{'When':'${esapi:encodeForJavaScript(rule.queueName)}', 'Value':'${esapi:encodeForJavaScript(rule.name)}','Text':'${esapi:encodeForJavaScript(esapi:encodeForHTML(rule.queueName))}-${esapi:encodeForJavaScript(esapi:encodeForHTML(rule.name))}'},
					</c:otherwise>
				</c:choose>
			</c:forEach>
			];
		</c:if>
	</c:if>




</script>
<c:if test="${reportSpecs.reportType=='viewFalsePositives' && reportDataSource == 'sor'}">
<script>
(function($){
    $.fn.numericOnly = function() {

        $(this).blur(function(event){
        	if(isNaN($(this).val())){
				$(this).val('0');
			}
		});
        $(this).keydown(function(event) {
             // Allow: backspace, delete, tab, escape, and enter
             if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || event.keyCode == 13 ||
                  // Allow: Ctrl+A
                 (event.keyCode == 65 && event.ctrlKey === true) ||
                  // Allow: home, end, left, right
                 (event.keyCode >= 35 && event.keyCode <= 39)
                ) {
                      // let it happen, don't do anything
                      return;
             } else {
                 // Ensure that it is a number and stop the keypress
                 if (event.shiftKey || (event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                     event.preventDefault();
                 }
             }
         });
     }
})(jQuery);
$(document).ready(function () {
$("#minScore").numericOnly();
$("#maxScore").numericOnly();
});

</script>
</c:if>

<form name="frmParams" id="frmParams" target="detail" action="<c:url value='/a_reporting.sj'/>" method="post">

<table id="reportDefinitionTable" class="configurationTable" style="width:660px;margin-left:5px" cellspacing="0" cellpadding="2" border="0" >
    <tr align="left" valign="top" >
      <td colspan="3" class="configurationTableSectionNoHover" style="padding:5px;"><fmt:message key="fcm.reports.form.reportDefinition.txt" /></td>
    </tr>


<tr class="configurationTableDataRow">

	<td align="left" valign="middle" nowrap align="right" style="padding-left:10px;padding-top:5px;">
		<label><input type="radio" value="d" name="dateType" checked onClick="switchEntry('E');">
		<fmt:message key="fcm.reports.form.dateRadio.txt" /></label>
		<label><input type="radio" value="r" name="dateType" onClick="switchEntry('R');">
		<fmt:message key="fcm.reports.form.rangeRadio.txt" /></label>
	</td>
	<td align="left" style="padding-left:10px;padding-top:5px;">
		<div id="Entry">
			<fmt:message key="fcm.reports.form.date.txt" />
			<input class="famTextEntry" id="calTarget1" name="headerDate" type="text" value="${esapi:encodeForHTMLAttribute(headerParams.headerDate)}" size="13" readonly>
			&nbsp;
			<a href="#" id="calAnchor1">
<!--			<img src="reports/images/calendarIcon.gif" class="icon" /> -->
				<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf198;"></span>
			</a>

		</div>

		<div id="Range" style="display:none">
			<fmt:message key="fcm.reports.form.startDate.txt" />:
			<input class="famTextEntry" id="calTarget2" name="headerStartDate" type="text" value="${esapi:encodeForHTMLAttribute(headerParams.headerStartDate)}" size="13" readonly>&nbsp;
			<a href="#" id="calAnchor2">
<!--			<img src="reports/images/calendarIcon.gif" border="0" name="calendar2" /> -->
				<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf198;"></span>
			</a>

			<fmt:message key="fcm.reports.form.endDate.txt" />:
			<input class="famTextEntry" id="calTarget3" name="headerEndDate" type="text" value="${esapi:encodeForHTMLAttribute(headerParams.headerEndDate)}" size="13" readonly>&nbsp;
			<a href="#" id="calAnchor3">
<!--			<img src="reports/images/calendarIcon.gif" border="0" name="calendar3" /> -->
				<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf198;"></span>
			</a>

		</div>
		<div id="calDiv1" style =" position:absolute;visibility:hidden;background-color:white;layer-background-color:white;z-Index:30"></div>
		<div id="calDiv2"	style =" position:absolute;visibility:hidden;background-color:white;layer-background-color:white;z-Index:30"></div>
		<div id="calDiv3"	style=" position:absolute;visibility:hidden;background-color:white;layer-background-color:white;z-Index:30"></div>
	</td>
	<td align="right"></td>
</tr>
<div id="restOfForm">
<c:if test="${time == 'y'}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow">
	<td align="right">
		<fmt:message key="fcm.reports.form.time.txt"/>:
	</td>
	<fmt:parseDate value="00:00:00" pattern="HH:mm:ss" var="zero" />
	<fmt:parseDate value="01:00:00" pattern="HH:mm:ss" var="one" />
	<fmt:parseDate value="02:00:00" pattern="HH:mm:ss" var="two" />
	<fmt:parseDate value="03:00:00" pattern="HH:mm:ss" var="three" />
	<fmt:parseDate value="04:00:00" pattern="HH:mm:ss" var="four" />
	<fmt:parseDate value="05:00:00" pattern="HH:mm:ss" var="five" />
	<fmt:parseDate value="06:00:00" pattern="HH:mm:ss" var="six" />
	<fmt:parseDate value="07:00:00" pattern="HH:mm:ss" var="seven" />
	<fmt:parseDate value="08:00:00" pattern="HH:mm:ss" var="eight" />
	<fmt:parseDate value="09:00:00" pattern="HH:mm:ss" var="nine" />
	<fmt:parseDate value="10:00:00" pattern="HH:mm:ss" var="ten" />
	<fmt:parseDate value="11:00:00" pattern="HH:mm:ss" var="eleven" />
	<fmt:parseDate value="12:00:00" pattern="HH:mm:ss" var="twelve" />
	<fmt:parseDate value="13:00:00" pattern="HH:mm:ss" var="thirteen" />
	<fmt:parseDate value="14:00:00" pattern="HH:mm:ss" var="fourteen" />
	<fmt:parseDate value="15:00:00" pattern="HH:mm:ss" var="fifteen" />
	<fmt:parseDate value="16:00:00" pattern="HH:mm:ss" var="sixteen" />
	<fmt:parseDate value="17:00:00" pattern="HH:mm:ss" var="seventeen" />
	<fmt:parseDate value="18:00:00" pattern="HH:mm:ss" var="eighteen" />
	<fmt:parseDate value="19:00:00" pattern="HH:mm:ss" var="nineteen" />
	<fmt:parseDate value="20:00:00" pattern="HH:mm:ss" var="twenty" />
	<fmt:parseDate value="21:00:00" pattern="HH:mm:ss" var="twentyone" />
	<fmt:parseDate value="22:00:00" pattern="HH:mm:ss" var="twentytwo" />
	<fmt:parseDate value="23:00:00" pattern="HH:mm:ss" var="twentythree" />


	<td align="left">
		<select name="startTime" >
			<option value="0"><fmt:formatDate value="${zero}" pattern="${timeFormat}"/></option>
			<option value="1"><fmt:formatDate value="${one}" pattern="${timeFormat}"/></option>
			<option value="2"><fmt:formatDate value="${two}" pattern="${timeFormat}"/></option>
			<option value="3"><fmt:formatDate value="${three}" pattern="${timeFormat}"/></option>
			<option value="4"><fmt:formatDate value="${four}" pattern="${timeFormat}"/></option>
			<option value="5"><fmt:formatDate value="${five}" pattern="${timeFormat}"/></option>
			<option value="6"><fmt:formatDate value="${six}" pattern="${timeFormat}"/></option>
			<option value="7"><fmt:formatDate value="${seven}" pattern="${timeFormat}"/></option>
			<option value="8"><fmt:formatDate value="${eight}" pattern="${timeFormat}"/></option>
			<option value="9"><fmt:formatDate value="${nine}" pattern="${timeFormat}"/></option>
			<option value="10"><fmt:formatDate value="${ten}" pattern="${timeFormat}"/></option>
			<option value="11"><fmt:formatDate value="${eleven}" pattern="${timeFormat}"/></option>
			<option value="12"><fmt:formatDate value="${twelve}" pattern="${timeFormat}"/></option>
			<option value="13"><fmt:formatDate value="${thirteen}" pattern="${timeFormat}"/></option>
			<option value="14"><fmt:formatDate value="${fourteen}" pattern="${timeFormat}"/></option>
			<option value="15"><fmt:formatDate value="${fifteen}" pattern="${timeFormat}"/></option>
			<option value="16"><fmt:formatDate value="${sixteen}" pattern="${timeFormat}"/></option>
			<option value="17"><fmt:formatDate value="${seventeen}" pattern="${timeFormat}"/></option>
			<option value="18"><fmt:formatDate value="${eighteen}" pattern="${timeFormat}"/></option>
			<option value="19"><fmt:formatDate value="${nineteen}" pattern="${timeFormat}"/></option>
			<option value="20"><fmt:formatDate value="${twenty}" pattern="${timeFormat}"/></option>
			<option value="21"><fmt:formatDate value="${twentyone}" pattern="${timeFormat}"/></option>
			<option value="22"><fmt:formatDate value="${twentytwo}" pattern="${timeFormat}"/></option>
			<option value="23"><fmt:formatDate value="${twentythree}" pattern="${timeFormat}"/></option>
		</select>
		-
		<select name="endTime" >
			<option value="0"><fmt:formatDate value="${one}" pattern="${timeFormat}"/></option>
			<option value="1"><fmt:formatDate value="${two}" pattern="${timeFormat}"/></option>
			<option value="2"><fmt:formatDate value="${three}" pattern="${timeFormat}"/></option>
			<option value="3"><fmt:formatDate value="${four}" pattern="${timeFormat}"/></option>
			<option value="4"><fmt:formatDate value="${five}" pattern="${timeFormat}"/></option>
			<option value="5"><fmt:formatDate value="${six}" pattern="${timeFormat}"/></option>
			<option value="6"><fmt:formatDate value="${seven}" pattern="${timeFormat}"/></option>
			<option value="7"><fmt:formatDate value="${eight}" pattern="${timeFormat}"/></option>
			<option value="8"><fmt:formatDate value="${nine}" pattern="${timeFormat}"/></option>
			<option value="9"><fmt:formatDate value="${ten}" pattern="${timeFormat}"/></option>
			<option value="10"><fmt:formatDate value="${eleven}" pattern="${timeFormat}"/></option>
			<option value="11"><fmt:formatDate value="${twelve}" pattern="${timeFormat}"/></option>
			<option value="12"><fmt:formatDate value="${thirteen}" pattern="${timeFormat}"/></option>
			<option value="13"><fmt:formatDate value="${fourteen}" pattern="${timeFormat}"/></option>
			<option value="14"><fmt:formatDate value="${fifteen}" pattern="${timeFormat}"/></option>
			<option value="15"><fmt:formatDate value="${sixteen}" pattern="${timeFormat}"/></option>
			<option value="16"><fmt:formatDate value="${seventeen}" pattern="${timeFormat}"/></option>
			<option value="17"><fmt:formatDate value="${eighteen}" pattern="${timeFormat}"/></option>
			<option value="18"><fmt:formatDate value="${nineteen}" pattern="${timeFormat}"/></option>
			<option value="19"><fmt:formatDate value="${twenty}" pattern="${timeFormat}"/></option>
			<option value="20"><fmt:formatDate value="${twentyone}" pattern="${timeFormat}"/></option>
			<option value="21"><fmt:formatDate value="${twentytwo}" pattern="${timeFormat}"/></option>
			<option value="22"><fmt:formatDate value="${twentythree}" pattern="${timeFormat}"/></option>
			<option value="23" selected="selected"><fmt:formatDate value="${zero}" pattern="${timeFormat}"/></option>

		</select>
	</td>
	<td align="right"></td>
</tr>
</c:if>
<c:if test="${newSched=='y'}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow">
	<td align="right">
		<fmt:message key="fcm.reports.form.reportType.txt" />:
	</td>

	<td align="left">
		<input type="radio" name="newSched" checked>
		<fmt:message key="fcm.reports.form.new.txt" />
		<input type="radio" name="newSched">
		<fmt:message key="fcm.reports.form.sched.txt" />


	</td>
	<td align="right"></td>
</tr>
</c:if>

<c:if test="${not empty businessUnit}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow"  valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.bu.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="businessUnit" name="businessUnit" class="famTextEntry" multiple size="${esapi:encodeForHTMLAttribute(lrgSelSize)}" onchange ="unselectList('BUcheckbox');">
			<c:forEach var="bu" items="${businessUnit}">
				<c:if test="${reportDataSource == null}">
					<option value="${esapi:encodeForHTMLAttribute(bu.buID)}" selected>${esapi:encodeForHTML(bu.buName)}</option>
				</c:if>
				<c:if test="${reportDataSource == 'sor'}">
					<option value="${esapi:encodeForHTMLAttribute(bu.name)}" selected>${esapi:encodeForHTML(bu.name)}</option>
				</c:if>

			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="BUcheckbox" name="BUcheckbox" type="checkbox" onclick= "selectList('businessUnit',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
</c:if>


<c:if test="${not empty strategyListR}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.strategy.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="strategy" name="strategy" class="famTextEntry" multiple size="${esapi:encodeForHTMLAttribute(lrgSelSize)} }" onChange="unselectList('Strcheckbox');">
			<c:forEach var="strategy" items="${strategyListR}">
				<c:set var="strategyName" value="${strategy.name}"/>
				<c:if test="${fn:length(strategy.name) > 50}">
					<c:set var="strategyName" value="${fn:substring(strategy.name,0,50)}..."/>
				</c:if>
				<c:if test="${reportDataSource == null}">
					<option value="${esapi:encodeForHTMLAttribute(strategy.id)}" selected>${esapi:encodeForHTML(strategy.businessUnitName)}- ${esapi:encodeForHTML(strategyName)}</option>
				</c:if>
				<c:if test="${reportDataSource == 'sor'}">
					<c:if test="${strategy.name!=null && strategy.name!='N/A'}">
						<option value="${esapi:encodeForHTMLAttribute(strategy.name)}" selected>${esapi:encodeForHTML(strategy.businessUnitName)}- ${esapi:encodeForHTML(strategyName)}</option>
					</c:if>
				</c:if>
			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="Strcheckbox" name="Strcheckbox" type="checkbox" onclick= "selectList('strategy',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
</c:if>

<c:if test="${not empty queueList}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">

	<td align="left">
		<fmt:message key="fcm.reports.form.queue.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="queue" name="queue" class="famTextEntry" multiple size="5" onChange="unselectList('Queuecheckbox');">
			<c:forEach var="queue" items="${queueList}">
				<c:if test="${reportDataSource == null}">
					<option value="${esapi:encodeForHTMLAttribute(queue.id)}" selected>${esapi:encodeForHTML(queue.businessUnitName)}-${esapi:encodeForHTML(queue.name)}</option>
				</c:if>
				<c:if test="${reportDataSource == 'sor'}">
					<c:if test="${status.first && reportSpecs.reportType=='viewRulesFired'}">
						<option value="?" selected>N/A</option>
					</c:if>
					<c:if test="${queue.name!=null && queue.name!='N/A'}">
						<option value="${esapi:encodeForHTMLAttribute(queue.name)}" selected>${esapi:encodeForHTML(queue.businessUnitName)}-${esapi:encodeForHTML(queue.name)}</option>
					</c:if>
				</c:if>
			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="Queuecheckbox" name="Queuecheckbox" type="checkbox" onclick= "selectList('queue',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
</c:if>

<c:if test="${not empty ruleList}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.rule.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="rule" name="rule" class="famTextEntry" size="3" multiple onChange="unselectList('rulecheckbox');">

			<c:forEach var="rule" items="${ruleList}">
				<option value="${esapi:encodeForHTMLAttribute(rule.name)}" selected>${esapi:encodeForHTML(rule.name)}</option>
			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="rulecheckbox" name="rulecheckbox" type="checkbox" onclick= "selectList('rule',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
</c:if>

<c:if test="${not empty groupList}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.team.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="group" name="group" class="famTextEntry" size="4" multiple onChange="unselectList('Groupcheckbox');">
			<c:forEach var="group" items="${groupList}">
				<option value="${esapi:encodeForHTMLAttribute(group.groupID)}" selected>${esapi:encodeForHTML(group.buName)}- ${esapi:encodeForHTML(group.groupName)}</option>
			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="Groupcheckbox" name="Groupcheckbox" type="checkbox" onclick= "selectList('group',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
</c:if>

<c:if test="${not empty supervisorList}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.supervisor.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="supervisor" name="supervisor" class="famTextEntry" size="4" multiple onChange="unselectList('Supcheckbox');">
			<c:forEach var="supervisor" items="${supervisorList}">
				<option value="${esapi:encodeForHTMLAttribute(supervisor.supervisorID)}" selected>${esapi:encodeForHTML(supervisor.buName)}- ${esapi:encodeForHTML(supervisor.supervisorName)}</option>
			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="Supcheckbox" name="Supcheckbox" type="checkbox" onclick= "selectList('supervisor',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
</c:if>

<c:if test="${not empty agentList}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.agent.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="agent" name="agent" class="famTextEntry" size="${esapi:encodeForHTMLAttribute(lrgSelSize)} }" multiple onChange="unselectList('Agentcheckbox');">
			<c:forEach var="agent" items="${agentList}">
				<option value="${esapi:encodeForHTMLAttribute(agent.agentID)}" selected>${esapi:encodeForHTML(agent.buName)}- ${esapi:encodeForHTML(agent.agentName)}</option>
			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="Agentcheckbox" name="Agentcheckbox" type="checkbox" onclick= "selectList('agent',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
</c:if>

<c:if test="${not empty fraudTypeList}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.fraudType.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="fraudType" name="fraudType" class="famTextEntry" size="4" multiple onChange="unselectList('Frdcheckbox');">
			<c:forEach var="fraudType" items="${fraudTypeList}">
				<option value="${esapi:encodeForHTMLAttribute(fraudType.lovCode)}" selected>${esapi:encodeForHTML(fraudType.lovDesc)}</option>
			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="Frdcheckbox" name="Frdcheckbox" type="checkbox" onclick= "selectList('fraudType',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
</c:if>

<c:if test="${not empty blockCodeList}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.systemBlockCode.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="sysBlockCode" name="sysBlockCode" class="famTextEntry" size="3" multiple onChange="unselectList('sysBlkcheckbox');">
			<c:forEach var="blockCode" items="${blockCodeList}">
				<c:if test="${blockCode.blockType=='S'}">
					<option value="${esapi:encodeForHTMLAttribute(blockCode.blockCode)}" selected>${esapi:encodeForHTML(blockCode.blockCode)}</option>
				</c:if>
			</c:forEach>
		</select>
	</td>
    <td nowrap align="left"> <input id="sysBlkcheckbox" name="sysBlkcheckbox" type="checkbox" onclick= "selectList('sysBlockCode',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.transactionBlockCode.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="transBlockCode" name="transBlockCode" class="famTextEntry" size="3" multiple onChange="unselectList('transBlkcheckbox');">
			<c:forEach var="blockCode" items="${blockCodeList}">
				<c:if test="${blockCode.blockType=='T'}">
					<option value="${esapi:encodeForHTMLAttribute(blockCode.blockCode)}" selected>${esapi:encodeForHTML(blockCode.blockCode)}</option>
				</c:if>
			</c:forEach>
		</select>
	</td>
    <td nowrap align="left"> <input id="transBlkcheckbox" name="transBlkcheckbox" type="checkbox" onclick= "selectList('transBlockCode',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td></tr>
</c:if>


<c:if test="${not empty multiOrg}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.multiOrg.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="multiOrg" name="multiOrg" class="famTextEntry" size="3" multiple onChange="unselectList('multiOrgcheckbox');">

			<c:forEach var="MO" items="${multiOrg}">
				<c:if test="${reportDataSource == null}">
					<option value="${esapi:encodeForHTMLAttribute(MO.multiOrgID)}" selected>${esapi:encodeForHTML(MO.multiOrgName)}</option>
				</c:if>
				<c:if test="${reportDataSource == 'sor'}">
					<option value="${esapi:encodeForHTMLAttribute(MO.name)}" selected>${esapi:encodeForHTML(MO.nodeName)}</option>
				</c:if>
			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="multiOrgcheckbox" name="multiOrgcheckbox" type="checkbox" onclick= "selectList('multiOrg',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
</tr>
</c:if>

<c:if test="${not empty alertType}">
<c:if test="${reportSpecs.reportType != 'viewIndCallHist'}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow"  valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.alertType.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="alertType" name="alertType" class="famTextEntry" <c:if test="${reportSpecs.reportType !='viewAlertsScoreBand'}">size="3" multiple </c:if> onChange="unselectList('alertcheckbox');">

			<c:forEach var="alertType" items="${alertType}">
				<c:if test="${reportDataSource == null}">
					<option value="${esapi:encodeForHTMLAttribute(alertType)}" selected="selected">
					<fmt:message key="${alertType}" bundle="${alertTypeLabelResourceBundle}"/>
				</c:if>
				<c:if test="${reportDataSource == 'sor'}">
					 <option value="${esapi:encodeForHTMLAttribute(alertType.code)}" selected="selected">
					 <fmt:message key="${alertType.code}" bundle="${alertTypeLabelResourceBundle}"/>
				</c:if>
				</option>
			</c:forEach>
		</select>
	</td>
	<td nowrap align="left"><c:if test="${reportSpecs.reportType != 'viewAlertsScoreBand'}"> <input id="alertcheckbox" name="alertcheckbox" type="checkbox" onclick= "selectList('alertType',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></c:if></td>
</tr>
</c:if>
<c:if test="${reportSpecs.reportType == 'viewIndCallHist'}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow"  valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.alertType.txt" />:
	</td>
	<td align="left">


			<c:forEach var="alertType" items="${alertType}">
				<label><input type ='radio' name="alertType" class="famTextEntry" value="${esapi:encodeForHTMLAttribute(alertType)}"/><fmt:message key="${alertType}" bundle="${alertTypeLabelResourceBundle}"/></label>
				<br/>
			</c:forEach>
		</select>
	</td>
	<td></td>
</tr>
</c:if>
</c:if>
<c:if test="${not empty activityTypeList}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.activityType.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="activityType" name="activityType" class="famTextEntry" onChange="deselectRest(this);">

			<c:forEach var="transactionType" items="${activityTypeList}">
				<option value="${esapi:encodeForHTMLAttribute(transactionType.gridName)}">${esapi:encodeForHTML(transactionType.gridDesc)}</option>
			</c:forEach>
		</select>
	</td>
	<td></td>
</tr>
</c:if>

<c:if test="${not empty countryCodeList}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.countryCode.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" id="countryCode" name="countryCode" class="famTextEntry" onChange="deselectRest(this);">
			<option value="" selected><fmt:message key="fcm.reports.form.all.txt" /></option>
			<c:forEach var="countryCode" items="${countryCodeList}">
				<option value="${esapi:encodeForHTMLAttribute(countryCode.lovCode)}">${esapi:encodeForHTML(countryCode.lovCode)} - ${esapi:encodeForHTML(countryCode.lovDesc)}</option>
			</c:forEach>
		</select>
	</td>
	<td></td>
</tr>
</c:if>

<c:if test="${ruleState=='true'}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.ruleState.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" name="ruleState" class="famTextEntry" onChange="deselectRest(this);">
			<option value="Production"><fmt:message key="fcm.reports.form.Production.txt" /></option>
			<option value="Testing"><fmt:message key="fcm.reports.form.Testing.txt" /></option>
		</select>
	</td>
	<td></td>
</tr>
</c:if>

<c:if test="${mccList!=null}">
	<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
	<tr class="configurationTableDataRow" valign="top">
		<td align="left">
			<fmt:message key="fcm.reports.header.mcc.txt" />:
		</td>
		<td align="left">
			<select style="width:550px;" id="mcc" name="mcc" class="famTextEntry" onChange="deselectRest(this);" size="3" multiple onChange="unselectList('mcccheckbox');">
				<c:forEach var="mcc" items="${mccList}">
				<option value="${mcc.mccCode}" selected>${mcc.mccCode}</option>
				</c:forEach>
			</select>
		</td>
		<td nowrap align="left"> <input id="mcccheckbox" name="mcccheckbox" type="checkbox" onclick= "selectList('mcc',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
	</tr>
</c:if>
<c:if test="${not empty resultNameList}">
	<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
	<tr class="configurationTableDataRow" valign="top">
		<td align="left">
			<fmt:message key="fcm.reports.header.resultName.txt" />:
		</td>
		<td align="left">
			<select style="width:550px;" id="resultNames" name="resultNames" class="famTextEntry" onChange="deselectRest(this);" size="3" multiple onChange="unselectList('resultNameCheckbox');">
				<c:forEach var="resultNames" items="${resultNameList}">
				<option value="${resultNames.resultName}" selected>${resultNames.resultName}</option>
				</c:forEach>
			</select>
		</td>
		<td nowrap align="left"> <input id="resultNamesCheckbox" name="resultNamesCheckbox" type="checkbox" onclick= "selectList('resultNames',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
	</tr>
</c:if>
<c:if test="${merCountryList!=null}">
	<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
	<tr class="configurationTableDataRow" valign="top">
		<td align="left">
			<fmt:message key="fcm.reports.header.merCountry.txt" />:
		</td>
		<td align="left">
			<select style="width:550px;" id="merCountry" name="merCountry" class="famTextEntry" onChange="deselectRest(this);" size="3" multiple onChange="unselectList('merCountrycheckbox');">
				<c:forEach var="merCountry" items="${merCountryList}">
				<option value="${merCountry.merCountryCode}" selected>${merCountry.merCountryCode}</option>
				</c:forEach>
			</select>
		</td>
		<td nowrap align="left"> <input id="merCountrycheckbox" name="merCountrycheckbox" type="checkbox" onclick= "selectList('merCountry',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>
	</tr>
</c:if>
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<c:if test="${scoreSingle=='true'}">
	<tr class="configurationTableDataRow" valign="top">
		<td> <fmt:message key="fcm.reports.form.fraudScore.txt"/>:</td>
		<td align="left" style="width:550px;" colspan="2">
			<select name="scoreSingle" class="famTextEntry" size="1">
	            <option value="score1" selected><fmt:message key="fcm.reports.form.fraudScore1.txt"/></option>
				<option value="score2"><fmt:message key="fcm.reports.form.fraudScore2.txt"/></option>
				<option value="score3"><fmt:message key="fcm.reports.form.fraudScore3.txt"/></option>
				<option value="score4"><fmt:message key="fcm.reports.form.fraudScore4.txt"/></option>
			</select>
			<fmt:message key="fcm.reports.form.minScore.txt" />:<input type="text" name="minScore" id="minScore" value="0" size="3" maxLength="4">
			<fmt:message key="fcm.reports.form.maxScore.txt" />:<input type="text" name="maxScore" id="maxScore" value="9999" size="3" maxLength="4">
		</td>

	</tr>
</c:if>

<c:if test="${scoreMulti=='true'}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		 <fmt:message key="fcm.reports.form.fraudScore.txt"/>:
	</td>
	<td align="left">
		<select style="width:550px;"  size="3" multiple  id="scoreMulti" name="scoreMulti" class="famTextEntry" onChange="unselectList('fraudScorecheckbox');" >
			<option value="score1" selected><fmt:message key="fcm.reports.form.fraudScore1.txt"/></option>
			<option value="score2" selected><fmt:message key="fcm.reports.form.fraudScore2.txt"/></option>
			<option value="score3" selected><fmt:message key="fcm.reports.form.fraudScore3.txt"/></option>
			<option value="score4" selected><fmt:message key="fcm.reports.form.fraudScore4.txt"/></option>
		</select>
	</td>

	<td nowrap align="left"> <input id="fraudScorecheckbox" name="fraudScorecheckbox" type="checkbox" onclick= "selectList('scoreMulti',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>

</tr>
</c:if>
<c:if test="${callResultList!=null}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		 <fmt:message key="fcm.reports.form.callResult.txt"/>:
	</td>
	<td align="left">
		<select style="width:550px;" size="3" multiple id="callResult" name="callResult" class="famTextEntry" onChange="unselectList('callResultcheckbox');" >
				<c:forEach var="callResult" items="${callResultList}">
				<option value="${callResult.RESULT_ID}" selected>${callResult.RESULT_NAME}</option>
				</c:forEach>
		</select>
	</td>
	<td nowrap align="left"> <input id="callResultcheckbox" name="callResultcheckbox" type="checkbox" onclick= "selectList('callResult',this);" checked="checked"/> <fmt:message key="fcm.reports.form.selectAll.txt" /></td>

</tr>
</c:if>
<c:if test="${serviceMode=='y'}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow" valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.outIn.txt" />:
	</td>
	<td align="left">
		<select style="width:550px;" name="outIn" class="famTextEntry" onChange="deselectRest(this);">
			<option value=""><fmt:message key="fcm.reports.form.all.txt" /></option>
			<option value="OUT"><fmt:message key="fcm.reports.form.outbound.txt" /></option>
			<option value="INB"><fmt:message key="fcm.reports.form.inbound.txt" /></option>



		</select>
	</td>
	<td></td>
</tr>
</c:if>

<c:if test="${entity=='y'}">
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr class="configurationTableDataRow"  valign="top">
	<td align="left">
		<fmt:message key="fcm.reports.form.value.txt" />:
	</td>
	<td align="left">
		<input type="text" name="entity" size="36" maxlength="100" required><i><fmt:message key="fcm.reports.form.required.txt"/></i>
	</td>
	<td align="right"></td>
</tr>
</c:if>
<tr class="configurationTableDataRow"><td colspan="3">&nbsp;</td></tr>
<tr>
    <td valign="top" colspan="3" class="configurationTableSectionNoHover" style="text-align:right;padding:5px 10px;">
      <button title="<fmt:message key="fcm.reports.runReport.txt" />" class="cfSectionBtn sapMBtn" id="runRuportButton" type="button" onclick="submitForm('${esapi:encodeForJavaScript(reportType)}');">
        <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
            <span class="sapMBtnContent"><fmt:message key="fcm.reports.runReport.txt" /></span>
            <span class="sapMBtnFocusDiv"></span>
        </span>
      </button>
  	</td>
</tr>
</table>


<input type="hidden" name="reportType" value="${esapi:encodeForHTMLAttribute(reportSpecs.reportType)}">
<input type="hidden" name="method" value="getReport">
<input type="hidden" name="reportName" value="${esapi:encodeForHTMLAttribute(reportSpecs.reportName)}">
<input type="hidden" name="reportID" value="${esapi:encodeForHTMLAttribute(reportSpecs.reportID)}">
<input type="hidden" name="sortable" value="${esapi:encodeForHTMLAttribute(reportSpecs.sortable)}">
<input type="hidden" name="showPagination" value="${esapi:encodeForHTMLAttribute(reportSpecs.showPagination)}">
<input type="hidden" name="showStatusBar" value="${esapi:encodeForHTMLAttribute(reportSpecs.showStatusBar)}">
<input type="hidden" name="reportNum" value="${esapi:encodeForHTMLAttribute(reportSpecs.reportNum)}">
<input type="hidden" name="reportTypes" value="${esapi:encodeForHTMLAttribute(reportSpecs.reportTypes)}">
<input type="hidden" name="params" value="${esapi:encodeForHTMLAttribute(reportSpecs.params)}">

<!--DATES TIMES-->
<input type="hidden" name="headerStartTime" value="">
<input type="hidden" name="headerEndTime" value="">
<input type="hidden" name="date" value="">
<input type="hidden" name="startDate" value="">
<input type="hidden" name="endDate" value="">
<input type="hidden" name="dateFormat" value="${esapi:encodeForHTMLAttribute(dateFormat)}">
<input type="hidden" name="timeFormat" value="${esapi:encodeForHTMLAttribute(timeFormat)}">
<c:set var="reportHeaderDate">
	<esapi:encodeForHTML><fmt:formatDate value="<%=new java.util.Date()%>" pattern="${dateTimeFormat}" timeZone="${userTimeZone}"/></esapi:encodeForHTML>
</c:set>
<input type="hidden" name="reportHeaderDate" value="${reportHeaderDate}"/>
<script>
	var unselect=true;
	function selectList(o,c){
		var lst = document.getElementById(o);
		for (var i =0; i < lst.length; i++)
		{
			if(c.checked == false){
				 lst[i].selected = false;}
			else{
				lst[i].selected =true;}
		}

	}
	function unselectList(c){
		if(unselect){
			var check = document.getElementById(c);
			if(check.checked == true) check.checked = false;
		}
		else{
			unselect=true;
		}
	}

</script>
<!---TIMEZONE-->
<input type="hidden" name="tz" value="">

<!--INTERNATIONALIZATION (needed for exports)-->
<input type="hidden" name="translations" value="<fmt:message key='fcm.reports.header.bu.txt'/>,<fmt:message key='fcm.reports.header.strategies.txt'/>,<fmt:message key='fcm.reports.header.queues.txt'/>,<fmt:message key='fcm.reports.header.team.txt'/>,<fmt:message key='fcm.reports.header.supervisors.txt'/>,<fmt:message key='fcm.reports.header.agents.txt'/>,<fmt:message key='fcm.reports.header.fraudTypes.txt'/>,<fmt:message key='fcm.reports.header.sysBlockCodes.txt'/>,<fmt:message key='fcm.reports.header.transBlockCodes.txt'/>,<fmt:message key='fcm.reports.header.country.txt'/>,<fmt:message key='fcm.reports.header.activityType.txt'/>,<c:if test="${headerParams.alertType!=null}"><fmt:message key='${headerParams.alertType[0]}' bundle='${alertTypeLabelResourceBundle}'/></c:if><c:if test="${headerParams.alertType==null}">none</c:if>,<fmt:message key='fcm.reports.header.accountNumber.txt'/>,<fmt:message key='fcm.reports.header.serviceMode.txt'/>,<fmt:message key='fcm.reports.header.startTime.txt'/>,<fmt:message key='fcm.reports.header.endTime.txt'/>,<fmt:message key='fcm.reports.header.report.txt'/>,<fmt:message key='fcm.reports.form.all.txt'/>,<fmt:message key='fcm.reports.header.queue.txt'/>,<fmt:message key='fcm.reports.header.alert.txt'/>,<fmt:message key='fcm.reports.header.multiOrg.txt'/>,<fmt:message key='fcm.reports.header.alertType.txt'/>,<fmt:message key='fcm.reports.header.rule.txt'/>,<fmt:message key='fcm.reports.header.ruleState.txt'/>,<fmt:message key='fcm.reports.header.minScore.txt'/>,<fmt:message key='fcm.reports.header.maxScore.txt'/>,<fmt:message key='fcm.reports.header.mcc.txt'/>,<fmt:message key='fcm.reports.header.merCountry.txt'/>,<fmt:message key='fcm.reports.form.fraudScore.txt'/>,<fmt:message key='fcm.reports.header.strategy.txt'/>,<fmt:message key='fcm.reports.form.callResult.txt'/>">
</div> <!-- "restOfForm" -->
</form> <!-- "frmParams" -->
<script type="text/javascript">
	$(document).ready(function(){

		$(document).keydown(function(e){
			if(e.which === 13)
				$('#runRuportButton').click();
			else if(e.which === 8){
					if(e.target.nodeName!=='INPUT' || e.target.id.indexOf('calTarget')===0){
						e.preventDefault();

					}
			}
		});
	});
</script>