jQuery.sap.require("sas.fscf.views.PrimaryTableView");

sap.ui.jsview("sas.fscf.views.AlertRows", {

	getControllerName: function() {
    	// mix in PrimaryTableView
    	jQuery.extend(true, this, sas.fscf.views.PrimaryTableView);

		return "sas.fscf.views.AlertRows";
	},

    getFieldtypesUrl: function() {
		var fieldtypesUrl = "rest/fieldtypes?type=alerts";
		return fieldtypesUrl;
    },

	getTableIdSuffix: function() {
		return "_AlertsTable";
	},

	attachContextMenu: function(table) {
	},

	getDefaultColumns: function() {
		var defaultColumns;
		if (this.isEstimation()) {
   			defaultColumns = sas.config.get('fscf').defaultAlertColumns;
           	var cf_lastEstimationAlertRowsColumns = sas.fscf.getCookie("cf_lastEstimationAlertRowsColumns");
           	if (cf_lastEstimationAlertRowsColumns) {
           		defaultColumns = cf_lastEstimationAlertRowsColumns;
           	}
		} else {
			defaultColumns = sas.config.get('fscf').defaultAlertColumns;
			if (sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties &&
				sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.defaultAlertRowsColumns &&
				sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.defaultAlertRowsColumns.length > 0) {
				defaultColumns = sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.defaultAlertRowsColumns;
			}
		}
		return defaultColumns;
	},

    pruneFieldsByAccess: function(fields) {
    },
    
    padFields: function(fields) {
    	return fields;
    },

    storeFields: function() {
    	var fieldsStr = this._fields.join(" ");
    	if (this.isEstimation()) {
    		sas.fscf.setCookie("cf_lastEstimationAlertRowsColumns", fieldsStr, sas.fscf.getNYearsFromNow(1));
    	} else {
    		if (!sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties) {
    			sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties = {};
    		}
    		sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].properties.defaultAlertRowsColumns = fieldsStr;
    		sas.fscf.getCurrentPageView().setDirty(true);
    	}
    },

    getSchema: function() {
		var schema = null;
		if (this.isCoding()) {
			schema = "swsrdb";
		} else if (this.isEstimation()) {
			schema = "swsedb";
		}
		return schema;
    },

    getEstimationFilter: function (estimation) {
        let answer = " and (estimation.id==" + estimation.estimationId;
        if (estimation.ruleId) {
            answer += " and id==" + estimation.ruleId;
            answer += " and rule.businessUnitId==" + this.getBUId();
        }
        return answer += ")";
    },

    getContextSpecificFields: function() {
    },

    getQueryUrl: function() {
		var url = 'rest/alerts/search?filter=businessUnitId==' + this.getBUId();
		if (this.isCoding()) {
			url += ' and id==' + sas.fscf.getCurrentPageView().jsonRule.id;
		} else if (this.isEstimation()) {
			url += this.getEstimationFilter(this.getEstimation());
		}
		url += '&schema=' + this.getSchema() + '&fields=' + encodeURIComponent(this.padFields(this._fields).join(","));
		return url;
    },

	annotateHeaderLabel: function(oLabel, fieldName) {
	}
});