sap.ui.jsview("sas.fscf.views.ExplorePageGuided", {
    getControllerName: function () {
    	return "sas.fscf.views.ExplorePageGuided";
    },

    createContent: function(oController) {
    	jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayout");
    	jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayoutArea");
        jQuery.sap.require("sap.m.Toolbar");
        jQuery.sap.require("sap.m.Label");
        jQuery.sap.require("sas.hc.m.RadioButton");
        jQuery.sap.require("sas.hc.m.DateTimePicker");
        jQuery.sap.require("sas.hc.ui.layout.Splitter");
        jQuery.sap.require("sas.hc.ui.layout.SplitterLayoutData");
        jQuery.sap.require("sas.fscf.views.GuidedHelper");
        jQuery.sap.require("sas.fscf.views.OperatorLogic");

    	var _this = this;

    	this.addStyleClass("cfGuidedView");

        var periodNumData = {
        		"numbers": [
        		]
        };
        for (var i = 1; i < 101; i++) {
        	periodNumData.numbers[periodNumData.numbers.length] = {
        			"key" : i,
        			"name" : i
        	}
        }
      	var periodNumSelect = new  sas.hc.m.Select({
    		id: this.sId + "PeriodNumSelect"
        });

      	periodNumSelect.setModel(new sap.ui.model.json.JSONModel(periodNumData));
      	periodNumSelect.bindAggregation("items", {
        	path: "/numbers",
            factory: function(sId, oContext) {
                return new sap.ui.core.ListItem(sId, {
              	  	key: oContext.getProperty("key"),
              	  	text: oContext.getProperty("name"),
                });
            }
        });
      	var cf_lastExplorePeriodNum = sas.fscf.getCookie("cf_lastExplorePeriodNum"); 
      	if (cf_lastExplorePeriodNum) {
          	periodNumSelect.setSelectedKey(cf_lastExplorePeriodNum);
      	} else {
          	periodNumSelect.setSelectedIndex(23);
      	}
      	periodNumSelect.attachChange(function(oEvent) {
      		sas.fscf.removeAllMessageStrips();
    		sas.fscf.setCookie("cf_lastExplorePeriodNum", this.getSelectedItem().getKey(), sas.fscf.getNYearsFromNow(1));
      		_this.update();
        });        
        
        var periodData = {
        		"periods" : [
        		    		{
        		    			"key" : "PT_s",
        		    			"name" : sas.fscf.rb.getText("rules.explorePage.guidedView.periods.seconds.txt")
        		    		},

        		    		{
        		    			"key" : "PT_m",
        		    			"name" : sas.fscf.rb.getText("rules.explorePage.guidedView.periods.minutes.txt")
        		    		},

        		    		{
        		    			"key" : "PT_h",
        		    			"name" : sas.fscf.rb.getText("rules.explorePage.guidedView.periods.hours.txt")
        		    		},

        		    		{
        		    			"key" : "P_d",
        		    			"name" : sas.fscf.rb.getText("rules.explorePage.guidedView.periods.days.txt")
        		    		},

        		    		{
        		    			"key" : "P_m",
        		    			"name" : sas.fscf.rb.getText("rules.explorePage.guidedView.periods.months.txt")
        		    		}
        		 ]
        };

      	var periodSelect = new  sas.hc.m.Select({
    		id: this.sId + "PeriodSelect"
        });
      	periodSelect.setModel(new sap.ui.model.json.JSONModel(periodData));
      	periodSelect.bindAggregation("items", {
        	path: "/periods",
            factory: function(sId, oContext) {
                return new sap.ui.core.ListItem(sId, {
              	  	key: oContext.getProperty("key"),
              	  	text: oContext.getProperty("name"),
                });
            }
        });
      	var cf_lastExplorePeriod = sas.fscf.getCookie("cf_lastExplorePeriod"); 
      	if (cf_lastExplorePeriod) {
          	periodSelect.setSelectedKey(cf_lastExplorePeriod);
        } else {
          	periodSelect.setSelectedIndex(2);
      	}
      	periodSelect.attachChange(function(oEvent) {
      		sas.fscf.removeAllMessageStrips();
    		sas.fscf.setCookie("cf_lastExplorePeriod", this.getSelectedItem().getKey(), sas.fscf.getNYearsFromNow(1));
      		_this.update();
        });
        
      	var cf_lastExploreOffsetNow = sas.fscf.getCookie("cf_lastExploreOffsetNow"); 
        var oRB1 = new sas.hc.m.RadioButton({
            id: this.sId + "OffsetRB1",
      		text: sas.fscf.rb.getText('explore.explorePage.guidedView.now.txt'),
            groupName: "offset",
            selected: (cf_lastExploreOffsetNow == "1" || !cf_lastExploreOffsetNow),
      		select: function() {
      			if (this.getSelected()) {
              		sas.fscf.removeAllMessageStrips();
          			offsetDateTime.setEnabled(false);      			
            		sas.fscf.setCookie("cf_lastExploreOffsetNow", "1", sas.fscf.getNYearsFromNow(1));      		
              		_this.update();
      			}
      		}
        });
        var oRB2 = new sas.hc.m.RadioButton({
            id: this.sId + "OffsetRB2",
            groupName: "offset",
            selected: (cf_lastExploreOffsetNow == "0"),
      		select: function() {
      			if (this.getSelected()) {
              		sas.fscf.removeAllMessageStrips();
      				offsetDateTime.setEnabled(true);
      				sas.fscf.setCookie("cf_lastExploreOffsetNow", "0", sas.fscf.getNYearsFromNow(1));
      				_this.update();
      			}
      		}
        });

      	var cf_lastExploreOffsetDateTime = sas.fscf.getCookie("cf_lastExploreOffsetDateTime");
      	var dateValue;
      	if (cf_lastExploreOffsetDateTime) {
      		try {
          		dateValue = new Date(parseInt(cf_lastExploreOffsetDateTime));
          		if (isNaN(dateValue.getTime())) {  // invalid
          			dateValue = new Date();
          		}
      		} catch(e) {  // invalid
      			dateValue = new Date();
      		}
      	} else {
      		dateValue = new Date();
      	}
      	var offsetDateTime = new sas.hc.m.DateTimePicker({
      		id: this.sId + 'OffsetDateTime',
      		dateValue: dateValue,
      		displayFormat: sas.config.get('fscf').dateTimeFormat,
      		width: "auto",
      		enabled: (cf_lastExploreOffsetNow == "0")
        });
      	
      	offsetDateTime.attachChange(function(oEvent) {
      		sas.fscf.removeAllMessageStrips();
    		sas.fscf.setCookie("cf_lastExploreOffsetDateTime", this.getDateValue().getTime(), sas.fscf.getNYearsFromNow(1));      		
      		_this.update();
      	});

    	var oToolbar1 = new sap.m.Toolbar({
        	id: this.sId + "Toolbar",
    	    content: [
      	      		  new sap.m.Label({
	    	      			id: this.sId + "ToolbarLastLabel",
	    	                text: sas.fscf.rb.getText("explore.explorePage.guidedView.last.txt")
	    	    	  }).addStyleClass("cfFirstToolbarItem cfLastLabel"),
    	              periodNumSelect,
    	              periodSelect,
      	      		  new sap.m.Label({
	    	      			id: this.sId + "ToolbarFromLabel",
	    	                text: sas.fscf.rb.getText("explore.explorePage.guidedView.priorTo.txt")
	    	    	  }),
	    	    	  oRB1,
	    	    	  oRB2,
    	              offsetDateTime
    	    ]
    	});

        var oSplitter1LayoutData1 = new sas.hc.ui.layout.SplitterLayoutData({
        	resizable: true,
            size: "17%"
        });
        var oSplitter1LayoutData2 = new sas.hc.ui.layout.SplitterLayoutData({
        	resizable: true,
        	size: "auto"
        });
        
        var oPaletteView = sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "PaletteView",
            viewName: "sas.fscf.views.Palette",
            height: "99%",
            layoutData: oSplitter1LayoutData1
        });
        oPaletteView.setExplore(true);
        if (sas.config.get('fscf').exploreFields && sas.config.get('fscf').exploreFields.length > 0) {
            oPaletteView.setFilterFields(sas.config.get('fscf').exploreFields.split(" "));
        }
        oPaletteView.lazyLoadContent();

        var oGridToolbarView = sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "GridToolbarView",
            viewName: "sas.fscf.views.GridToolbar"
        });
        oGridToolbarView.setExplore(true);

        var oSplitter2LayoutData1 = new sas.hc.ui.layout.SplitterLayoutData({
        	resizable: true,
            size: "60%"
        });
        var oSplitter2LayoutData2 = new sas.hc.ui.layout.SplitterLayoutData({
        	resizable: true,
        	size: "auto"
        });
        
        var oGridView = sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "GridView",
            viewName: "sas.fscf.views.Grid",
            layoutData: oSplitter2LayoutData1
        });
        oGridView.setExplore(true);
        oGridView.setStartMessage(sas.fscf.rb.getText("explore.explorePage.guidedView.grid.start.txt"));
        oGridView.lazyLoadContent();

        oGridToolbarView.setGrid(oGridView);
        oGridToolbarView.lazyLoadContent();

        var oFormView = sap.ui.view({
            type: sap.ui.core.mvc.ViewType.JS,
            id: this.sId + "FormView",
            viewName: "sas.fscf.views.Form",
            visible: false
        });

        var oRelatedRowsView = sap.ui.view({
        	type: sap.ui.core.mvc.ViewType.JS,
        	id: this.sId + "RelatedRowsView",
        	viewName: "sas.fscf.views.RelatedRows",
        	layoutData: oSplitter2LayoutData2
        });
        oRelatedRowsView.setExplore(true);
        oRelatedRowsView.lazyLoadContent();

    	var oRelatedRowsLayout = new sas.hc.ui.layout.VerticalLayout({
			id: this.sId + "RelatedRowsLayout",
			width: "100%",
			content: [
				oFormView,          // hidden
				oRelatedRowsView
			]
    	});

        var oSplitter2 = new sas.hc.ui.layout.Splitter({
            id: this.sId + 'Splitter2',
            contentAreas: [oGridView, oRelatedRowsView],
            orientation: sap.ui.core.Orientation.Vertical,
            width: "100%",
            height: "100%"
        });
        oSplitter2.addStyleClass("cfSplitter2");

        var oBorderLayoutTop2 = new sas.hc.ui.commons.layout.BorderLayoutArea({
            id: this.sId + "BorderLayoutTop2",
			size: "2rem",
			content: [
			          oGridToolbarView
			]
		});
        oBorderLayoutTop2.addStyleClass("cfGridToolbarArea");

        var oBorderLayout2 = new sas.hc.ui.commons.layout.BorderLayout({
            id: this.sId + "BorderLayout2",
    		top: oBorderLayoutTop2,
    	    center: new sas.hc.ui.commons.layout.BorderLayoutArea({
                id: this.sId + "BorderLayoutCenter2",
    			content: [
    			          oSplitter2
      			]
      		}),
        	layoutData: oSplitter1LayoutData2
    	});

        var oSplitter1 = new sas.hc.ui.layout.Splitter({
            id: this.sId + 'Splitter1',
            contentAreas: [oPaletteView, oBorderLayout2],
            width: "100%",
            height: "100%"
        });

        var oBorderLayout1 = new sas.hc.ui.commons.layout.BorderLayout({
            id: this.sId + "BorderLayout1",
    		top: new sas.hc.ui.commons.layout.BorderLayoutArea({
                id: this.sId + "BorderLayoutTop1",
    			size: "2rem",
    			content: [
    			          oToolbar1
    			]
    		}),
    	    center: new sas.hc.ui.commons.layout.BorderLayoutArea({
                id: this.sId + "BorderLayoutCenter1",
    			content: [
    			          oSplitter1
      			]
      		})
    	});

        return oBorderLayout1;
    },

	update: function() {
		this.getGridToolbar().initializePopulationIndicator();
		this.getGrid().update();
		this.getRelatedRows().update();
	},
	
	getTsoffset: function() {
      	var cf_lastExploreOffsetNow = sas.fscf.getCookie("cf_lastExploreOffsetNow");
      	if (cf_lastExploreOffsetNow == "1") {
      		/*
            * Backend requires that
            * now is null (not sent to BE)
			*/
      		return null;
      	}
      	var cf_lastExploreOffsetDateTime = sas.fscf.getCookie("cf_lastExploreOffsetDateTime");
      	var date;
      	if (cf_lastExploreOffsetDateTime) {
      		try {
          		date = new Date(parseInt(cf_lastExploreOffsetDateTime));
          		if (isNaN(date.getTime())) {  // invalid
      		    /*
                 * Backend requires that
                 * now is null (not sent to BE)
			     */
          			date = null;
          		}
      		} catch(e) {  // invalid
      		/*
            * Backend requires that
            * now is null (not sent to BE)
			*/
      			date = null;
      		}
      	} else {
      		/*
            * Backend requires that
            * now is null (not sent to BE)
			*/
      		date = null;
      	}
      	
      	if (date)
      		return date.getTime();
      	
      	return date;
	},
	
	getTsperiod: function() {
      	var cf_lastExplorePeriodNum = sas.fscf.getCookie("cf_lastExplorePeriodNum");
      	if (!cf_lastExplorePeriodNum) {
      		cf_lastExplorePeriodNum = 24;
      	}
      	var cf_lastExplorePeriod = sas.fscf.getCookie("cf_lastExplorePeriod"); 
      	if (!cf_lastExplorePeriod) {
      		cf_lastExplorePeriod = "PT_h";
      	}
      	return cf_lastExplorePeriod.replace("_", cf_lastExplorePeriodNum);
	},
	
    getPalette: function() {
    	return sap.ui.getCore().byId("ExplorePageGuidedViewPaletteView");
    },

    getGridToolbar: function() {
    	return sap.ui.getCore().byId("ExplorePageGuidedViewGridToolbarView");
    },

    getGrid: function() {
    	return sap.ui.getCore().byId("ExplorePageGuidedViewGridView");
    },

    getForm: function() {
    	return sap.ui.getCore().byId("ExplorePageGuidedViewFormView");
    },

    getRelatedRows: function() {
    	return sap.ui.getCore().byId("ExplorePageGuidedViewRelatedRowsView");
    }

});
