sap.ui.jsview("sas.fscf.views.GridToolbar", {
    getControllerName: function () {
        return "sas.fscf.views.GridToolbar";
    },

    _grid: null,
    
    getGrid: function() {
    	return this._grid;
    },
    
    setGrid: function(grid) {
    	this._grid = grid;
    },
    
    _bExplore: false,

    isExplore: function() {
    	return this._bExplore;
    },

    setExplore: function(bExplore) {
    	this._bExplore = bExplore;
    },

    createContent: function(oController) {
    },

    lazyLoadContent: function() {
      if (this.getContent().length == 0) {
        jQuery.sap.require("sap.m.Toolbar");
        jQuery.sap.require("sap.m.ToolbarSpacer");
        jQuery.sap.require("sas.hc.m.Label");
        jQuery.sap.require("sas.hc.m.MenuButton");
        jQuery.sap.require("sas.hc.m.Menu");
        jQuery.sap.require("sas.hc.m.MenuItem");
        jQuery.sap.require("sas.hc.m.Button");
        jQuery.sap.require("sas.hc.m.ToggleButton");
        jQuery.sap.require("sas.hc.m.ProgressIndicator");
		
    	var _this = this;

    	this.addStyleClass("cfGridToolbarView");

    	var oTogglePercentagesButton = new sas.hc.m.ToggleButton({
	       	id: this.sId + "GridToolbarPercentagesButton",
	    	icon: 'sap-icon://hc/autocompleteMacroStatements',
	   		tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.percentages.txt"),
	   		ariaLabel: sas.fscf.rb.getText("rules.rulesPage.guidedView.percentages.txt"),
	   		press: function(oEvent) {
	   			_this.getGrid().togglePercentages(oEvent.mParameters.pressed);
	   		}
		});
    	// Workaround a ToggleButton bug where the icon on the button does
    	// not inherit the title and aria label of the button
    	oTogglePercentagesButton.onAfterRendering = function() {
	    	if (sas.hc.m.ToggleButton.prototype.onAfterRendering) {
        		sas.hc.m.ToggleButton.prototype.onAfterRendering.apply(this);
        	}
        	// must be set after rendering when the dom ref will exist
	    	var icon = $("#"+this.getDomRef().id+"-img")[0]; 
        	icon.setAttribute("title", sas.fscf.rb.getText("rules.rulesPage.guidedView.percentages.txt"));
        	icon.setAttribute("aria-label", sas.fscf.rb.getText("rules.rulesPage.guidedView.percentages.txt"));
    	};

    	var oProgIndicator = new sas.hc.m.ProgressIndicator({
		    id: this.sId + 'GridToolbarPopulationIndicator',
		    width : "33%",
		    percentValue : 100,
		    displayValue : sas.fscf.percentFormatter.format(1),
		    showValue : true,
		    state: sap.ui.core.ValueState.None
		}); 
    		
       	var grid = _this.getGrid();
        var oToolbar = new sap.m.Toolbar({
        	id: this.sId + "GridToolbar",
    	    content: [
   			      	new sas.hc.m.MenuButton({
   			        	id: this.sId + "GridToolbarSortButton",
   			    		icon: 'sap-icon://hc/sortGeneric',
 	   			    	tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.sort.txt"),
 	   			    	showDownArrowIconOnly: true,
   	   			    	menu: new sas.hc.m.Menu({
	                          items: [
	                              new sas.hc.m.MenuItem({
  			                   	       id: _this.sId + 'SortByCountDescendingMenuItem',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byCountDescending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_COUNT_DESCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       		               press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_COUNT_DESCENDING);
   			       		            	   _this.updateMenuIcons(this);
   			       		               }
	                              }),
	                              new sas.hc.m.MenuItem({
  			                           id: _this.sId + 'SortByCountAscendingMenuItem',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byCountAscending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_COUNT_ASCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_COUNT_ASCENDING);
   			       		            	   _this.updateMenuIcons(this);
   			      	    			   }
	                              }),
	                              new sas.hc.m.MenuItem({
  			                           id: _this.sId + 'SortByValueDescendingMenuItem',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byValueDescending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_VALUE_DESCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_VALUE_DESCENDING);
   			       		            	   _this.updateMenuIcons(this);
   			      	    			   }
	                              }),
	                              new sas.hc.m.MenuItem({
  			                     	   id: _this.sId + 'SortByValueAscendingMenuItem',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byValueAscending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_VALUE_ASCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_VALUE_ASCENDING);
   			       		            	   _this.updateMenuIcons(this);
   			      	    			   }
	                              }),
	                              new sas.hc.m.MenuItem({
  			                     	   id: _this.sId + 'SortByFraudDescendingMenuItem',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byFraudDescending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_FRAUD_DESCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_FRAUD_DESCENDING);
   			       		            	   _this.updateMenuIcons(this);
   			      	    			   }
	                              }),
	                              new sas.hc.m.MenuItem({
  			                     	   id: _this.sId + 'SortByFraudAscendingMenuItem',
   			       		               text: sas.fscf.rb.getText('rules.rulesPage.guidedView.sort.byFraudAscending.txt'),
   			       		               icon: (grid.getSortOrder() == grid.SORT_BY_FRAUD_ASCENDING) ? "sap-icon://hc/checkmark" : "sap-icon://hc/blank",
   			       	    			   press: function() {
   			       		            	   grid.setSortOrder(grid.SORT_BY_FRAUD_ASCENDING);
   			       		            	   _this.updateMenuIcons(this);
   			      	    			   }
	                              })
	                          ]
   	   			    	})
   					}),
   			      	new sas.hc.m.Button({
   			        	id: this.sId + "GridToolbarRemoveAllButton",
   			    		icon: 'sap-icon://hc/clearAll',
   			    		tooltip: sas.fscf.rb.getText("rules.rulesPage.guidedView.removeAll.txt"),
   			    		ariaLabel: sas.fscf.rb.getText("rules.rulesPage.guidedView.removeAll.txt"),
   			    		press: function() {
   			    			_this.getGrid().removeAllPanels();
   			    		}
   					}),
   					oTogglePercentagesButton,
  			      	new sap.m.ToolbarSpacer({
					}),
    	      		new sas.hc.m.Label({
    	                text: sas.fscf.rb.getText("rules.rulesPage.guidedView.population.txt")
    	    		}),
    	    		oProgIndicator
    	    ]
    	});
        
        //this.initializePopulationIndicator();
        
        this.addContent(oToolbar);
      }
    },

    updateMenuIcons: function(activeMenuItem) {
    	var menu = activeMenuItem.getParent();
    	for (var i = 0; i < menu.getItems().length; i++) {
    		menu.getItems()[i].setIcon("sap-icon://hc/blank");
    	}
		activeMenuItem.setIcon("sap-icon://hc/checkmark");
    },
    
    initializePopulationIndicator: function() {
    	var _this = this;
        sas.ajax({url:sas.fscf.getQueryUrl("search", (_this.isExplore() ? "esdb" : null), "*:*", ""), dataType:"json", headers:sas.fscf.getAjaxHeaders()})
        .done(function(oData){
			if (oData && oData[Object.keys(oData)[0]]) {
				var current = oData[Object.keys(oData)[0]]["match"];
				_this.getGrid()._overallCurrentPopulation = current;
				var total = oData[Object.keys(oData)[0]]["total"];
				_this.getGrid()._overallTotalPopulation = total;
				var percent = (total === 0) ? 0 : (current / total);
				var oProgIndicator = sap.ui.getCore().byId(_this.sId + "GridToolbarPopulationIndicator");
				if (oProgIndicator) {
					oProgIndicator.setPercentValue(percent * 100);
					oProgIndicator.setDisplayValue(sas.fscf.percentFormatter.format(percent) + " (" + sas.fscf.rb.getText("rules.rulesPage.guidedView.population.xofy.fmt.txt", [sas.fscf.floatFormatter.format(current), sas.fscf.floatFormatter.format(total)]) + ")");
				}
			}
      }).fail(function(oObj,textStatus){
      });    	
    }
});
